<?php

class Bootstrap extends Zend_Application_Bootstrap_Bootstrap
{
    protected function _initAutoloader()
    {
        $options = $this->getOptions();
	    define('MODULES_DIR', $options['resources']['frontController']['moduleDirectory']);
        $autoloader = Zend_Loader_Autoloader::getInstance();
        $autoloader->pushAutoloader(new Unl_Loader_Autoloader());
    }
    
    protected function _initDb()
    {
        $this->getPluginResource('db')->init();
        $db = Zend_Db_Table::getDefaultAdapter();
        $db->query('SET NAMES utf8');
        Zend_Registry::set('db', $db);
    }

    protected function _initCache()
    {
        Zend_Registry::set(
            'cache',
            $this->getPluginResource('cachemanager')->getCacheManager()->getCache('memcache')
        );
        error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING ^ E_STRICT);
    }
    
    protected function _initConfig()
    {
        Zend_Registry::set('config', $this->getOptions());
    }
}

