<?php

class Courses_ContactsAdminController extends Creq_Controller_Action
{
    public function preDispatch()
    {
        $user = Auth_UserModel::findCurrentUser();
        $roles = Auth_GroupModel::findByUser($user);
        if (!in_array(1, $roles->getId())) {
            throw new Exception('You must be logged in to view this page.');
        }
    }
    
    public function indexAction()
    {
        $collegesTable = new Zend_Db_Table('creqColleges');
        $departmentsTable = new Zend_Db_Table('creqDepartments');
        $subjectsTable = new Zend_Db_Table('creqSubjects');
        
        $colleges = array();
        $select = $collegesTable->select()->order('description');
        foreach ($collegesTable->fetchAll($select) as $row) {
            $colleges[$row->collegeId] = $row;
        }
        
        $departments = array();
        $collegeDepartments = array();
        $select = $departmentsTable->select()->order('name');
        foreach ($departmentsTable->fetchAll($select) as $row) {
            $departments[$row->departmentId] = $row;
            $collegeDepartments[$row->college][$row->departmentId] = $row;
        }
        
        $subjects = array();
        $departmentSubjects = array();
        $select = $subjectsTable->select()->order('name');
        foreach ($subjectsTable->fetchAll($select) as $row) {
            $subjects[$row->subjectId] = $row;
            $departmentSubjects[$row->department][$row->subjectId] = $row;
        }
        
        $groupsModels = Auth_GroupModel::findAll(false);
        $groupsModels->orderBy('getName');
        foreach ($groupsModels as $group) {
            $groups[$group->getId()] = $group->getName();
        }

        $this->view->colleges = $colleges;
        $this->view->departments = $departments;
        $this->view->subjects = $subjects;
        $this->view->collegeDepartments = $collegeDepartments;
        $this->view->departmentSubjects = $departmentSubjects;
        $this->view->groups = $groups;
    }
    
    public function indexPostAction()
    {
        $in = $this->_getAllParams();
        
        $collegesTable = new Zend_Db_Table('creqColleges');
        $departmentsTable = new Zend_Db_Table('creqDepartments');
        $subjectsTable = new Zend_Db_Table('creqSubjects');
        
        foreach ($collegesTable->fetchAll() as $row) {
            if ($in['college'][$row->collegeId] > 0) {
                $row->contactGroup = $in['college'][$row->collegeId];
            } else {
                $row->contactGroup = NULL;
            }
            $row->save();
        }
        
        foreach ($departmentsTable->fetchAll() as $row) {
            if ($in['department'][$row->departmentId] > 0) {
                $row->contactGroup = $in['department'][$row->departmentId];
            } else {
                $row->contactGroup = NULL;
            }
            $row->save();
        }
        
        foreach ($subjectsTable->fetchAll() as $row) {
            if ($in['subject'][$row->subjectId] > 0) {
                $row->contactGroup = $in['subject'][$row->subjectId];
            } else {
                $row->contactGroup = NULL;
            }
            $row->save();
        }
        
        $this->_redirect('/courses/contacts-admin');
    }
}
