<?php

class Courses_SubjectAdminController extends Creq_Controller_Action
{
    public function preDispatch()
    {
        $user = Auth_UserModel::findCurrentUser();
        $roles = Auth_GroupModel::findByUser($user);
        if (!in_array(1, $roles->getId())) {
            throw new Exception('You must be logged in to view this page.');
        }
    }

    public function indexAction()
    {
        $this->view->subjects = Courses_CourseModel::getSubjectsFull();
    }

    public function renameSubjectPostAction()
    {
        $in = $this->_getAllParams();

        $db = Zend_Registry::get('db');
        if (!$db instanceof Zend_Db_Adapter_Abstract) {
            return;
        }

        if (!in_array($in['newSubjectCode'], Courses_CourseModel::getSubjects())) {
            $sql = 'INSERT INTO creqSubjects (name, description, department, retired) '
                 . $db->quoteInto('SELECT ?, ', $in['newSubjectCode'])
                 . $db->quoteInto('?, ', $in['newSubjectDescription'])
                 .   "department, 'no' "
                 . 'FROM creqSubjects '
                 . $db->quoteInto('WHERE name = ?', $in['currentSubject'])
                 ;
            $db->query($sql);
        }
        $sql = 'UPDATE creqSubjects '
             . "SET retired = 'yes' "
             . $db->quoteInto('WHERE name = ?', $in['currentSubject']);
        $db->query($sql);

        Courses_CourseModel::updateSubjectCode($in['currentSubject'], $in['newSubjectCode'], $in['newEffectiveSemester']);

        echo 'Done!';
        exit;
    }

    public function removeXCrosslistingsAction()
    {
        Courses_CourseModel::removeCrosslistingsWithLetter('x');

        echo 'Done!'; exit;
    }
}
