<?php

require_once APPLICATION_PATH . '/modules/requests/controllers/ViewController.php';

class Courses_ViewController extends Requests_ViewController
{
    public function indexAction()
    {
    	$in = $this->getAllParams();
        $this->_commonIndexAction();

        $request = $this->view->request;

        $myRequestSession = new Zend_Session_Namespace('My Requests');
    	if ($in['type'] == 'session') {
    		$session = new Zend_Session_Namespace('Edit Request ' . $in['id']);
    		$course = $session->course;
    		$parentCourse = $session->parentCourse;
    	} else {
            $course = Courses_CourseModel::findLatestOfRequest($request);

	        $parentCourse = null;
	        if (in_array($request->getType(), array('ChangeCourse', 'AddISToCourse', 'AddACEAndChangeCourse', 'RemoveACEAndChangeCourse', 'AdminEdit', 'ChangeACE', 'RecertifyACE', 'SeparateGrad', 'RecertifyACEAndChangeCourse', 'ChangeACEAndChangeCourse'))) {
	            $parentCourse = Courses_CourseModel::findParentOfRequest($request);
	        }
    	}

    	$this->view->course = $course;
    	$this->view->parentCourse = $parentCourse;
    	$this->view->isRequestValid = $course->isValid() && $request->isValid();
    }

    public function printAction()
    {
        $requestId = $this->getRequest()->getParam('id');
        $request = Requests_RequestModel::find($requestId);
        $course = Courses_CourseModel::findLatestOfRequest($request);

        $parentCourse = null;
        if (in_array($request->getType(), array('ChangeCourse', 'AddACEAndChangeCourse', 'SeparateGrad', 'RecertifyACEAndChangeCourse', 'ChangeACEAndChangeCourse'))) {
            $parentCourse = Courses_CourseModel::findParentOfRequest($request);
        }

        $this->view->request = $request;
        $this->view->course = $course;
        $this->view->parentCourse = $parentCourse;

        $this->_helper->layout->setLayout('naked-layout');
    }
}

