<?php

class Courses_UtilityModel implements Creq_Model_UtilityInterface
{
    static public function loadAdditionalData(&$data)
    {
        $requests = array();
        foreach ($data as $i => $record) {
            $requests[$i] = $record['request'];
        }

        $courses = Courses_CourseModel::findLatestOfRequest($requests);
        $parentCourses = Courses_CourseModel::findParentOfRequest($requests);
        
        foreach ($data as $i => &$record) {
            $record['course'] = $courses[$i];
            $record['parentCourse'] = ($parentCourses[$i] ? $parentCourses[$i] : $courses[$i]);
        }
        foreach ($data as $i => &$record) {
            $course = ($parentCourses[$i] ? $parentCourses[$i] : $courses[$i]);
            $record['extra']['course'] = $course->getCourseCode();
            $record['extra']['college'] = $course->getCollege();
        }
        unset($record);
    }

    static public function getCollegesForRequests($requests)
    {
        $requestColleges = array();

        $requestParentCourses = Courses_CourseModel::findParentOfRequest($requests);
        $requestCurrentCourses = Courses_CourseModel::findLatestOfRequest($requests);
        foreach ($requests as $request) {
            $course = $requestParentCourses[$request->getId()];
            if (!$course) {
                $course = $requestCurrentCourses[$request->getId()];
            }
            $requestColleges[$request->getId()] = $course->getCollege();
        }

        return $requestColleges;
    }

    static public function getMajorsForRequests($requests)
    {
        $requestMajors = array();
        foreach ($requests as $request) {
            $requestMajors[$request->getId()] = NULL;
        }

        return $requestMajors;
    }
}
