<?php

class FourYearPlans_NewController extends Creq_Controller_Action
{
    public function indexAction()
    {
        $this->view->messages = $this->_helper->getHelper('FlashMessenger')->getMessages();

        $fourYearPlans = FourYearPlans_FourYearPlanModel::findAllActive();
        $existingMajors = array();
        foreach ($fourYearPlans as $fourYearPlan) {
            $existingMajors[$fourYearPlan->getFourYearPlanId()] = $fourYearPlan->getMajor();
        }
        asort($existingMajors);
        $this->view->existingMajors = $existingMajors;
        $this->view->majors = Bulletin_UtilityModel::getMajors();
    }

    public function createAction()
    {
        $in = $this->getAllParams();

        $activeRequests = FourYearPlans_FourYearPlanModel::findActiveRequestByMajorId($in['major']);
        foreach ($activeRequests as $activeRequest) {
            $href = $this->view->baseUrl('/requests/view/index/id/' . $activeRequest->getId());
            $this->_helper->getHelper('FlashMessenger')->addMessage(
                "There is already an <a href=\"$href\">active request</a> for that college/major"
            );
            $this->redirect('/fouryearplans/new');
        }

        $request = Requests_RequestModel::fetchNew();
        $request->setModule('fouryearplans');
        $user = Auth_UserModel::findCurrentUser();
        $request->setOwner($user);
        $request->setJustification('--None Required--');

        $fourYearPlan = FourYearPlans_FourYearPlanModel::findByMajorId($in['major']);
        if (!$fourYearPlan) {
            $fourYearPlan = FourYearPlans_FourYearPlanModel::fetchNew();
            $fourYearPlan->setMajorId($in['major']);
            $previousFourYearPlan = NULL;
            $request->setType('NewFourYearPlan');
        } else {
            $previousFourYearPlan = FourYearPlans_FourYearPlanModel::findByFourYearPlanId($fourYearPlan->getFourYearPlanId());
            $fourYearPlan = clone $fourYearPlan;
            $request->setType('ChangeFourYearPlan');
        }

        $id = bin2hex(openssl_random_pseudo_bytes('16'));
        $session = new Zend_Session_Namespace('Edit Request ' . $id);
        $session->fourYearPlan = $fourYearPlan;
        $session->previousFourYearPlan = $previousFourYearPlan;
        $session->request = $request;
        unset($session->currentSavedRequestId);

        $this->redirect('/fouryearplans/edit/index/id/' . $id);
    }
}
