<?php

class FourYearPlans_UtilityModel implements Creq_Model_UtilityInterface
{
    static public function loadAdditionalData(&$data)
    {
        $requests = array();
        foreach ($data as $i => $record) {
            $requests[$i] = $record['request'];
        }

        $requestPlans = FourYearPlans_FourYearPlanModel::findLatestOfRequest($requests);

        foreach ($data as $i => &$record) {
            $record['extra']['Major'] = $requestPlans[$record['request']->getId()]->getMajor();
            $record['extra']['College'] = $requestPlans[$record['request']->getId()]->getCollege();
        }
        unset($record);
    }

    static public function getCollegesForRequests($requests)
    {
        $requestColleges = array();

        $requestParentFyps = FourYearPlans_FourYearPlanModel::findParentOfRequest($requests);
        $requestCurrentFyps = FourYearPlans_FourYearPlanModel::findLatestOfRequest($requests);
        foreach ($requests as $request) {
            $fyp = $requestParentFyps[$request->getId()];
            if (!$fyp) {
                $fyp = $requestCurrentFyps[$request->getId()];
            }
            $requestColleges[$request->getId()] = $fyp->getCollege();
        }

        return $requestColleges;
    }

    static public function getMajorsForRequests($requests)
    {
        $requestMajors = array();

        $requestParentFyps = FourYearPlans_FourYearPlanModel::findParentOfRequest($requests);
        $requestCurrentFyps = FourYearPlans_FourYearPlanModel::findLatestOfRequest($requests);
        foreach ($requests as $request) {
            $fyp = $requestParentFyps[$request->getId()];
            if (!$fyp) {
                $fyp = $requestCurrentFyps[$request->getId()];
            }
            $requestMajors[$request->getId()] = $fyp->getMajor();
        }

        return $requestMajors;
    }
}
