<?php

class LearningOutcomes_EditController extends Creq_Controller_Action
{
    public function indexAction()
    {
        $in = $this->getAllParams();
        $session = new Zend_Session_Namespace('Edit Request ' . $in['id']);
        $learningOutcome = $session->learningOutcome;
        $request = $session->request;

        $this->view->learningOutcome = $learningOutcome;
        $this->view->request = $request;
        $this->view->formSessionId = $in['id'];
    }

    public function editPostAction()
    {
        $in = $this->getAllParams();
        $session = new Zend_Session_Namespace('Edit Request ' . $in['id']);
        $learningOutcome = $session->learningOutcome;

        $learningOutcome->clearDetails();
        foreach ($in['details'] as $concentrationId => $details) {
            if ($concentrationId == 'stub') {
                continue;
            }
            $concentration = $in['concentrations'][$concentrationId];
            foreach ($details as $name => $text) {
                $learningOutcome->setDetail($concentration, $name, $text);
            }
        }


        $this->redirect('/learningoutcomes/view/index/type/session/id/' . $in['id']);
    }

    public function submitPostAction()
    {
        $in = $this->getAllParams();
        $session = new Zend_Session_Namespace('Edit Request ' . $in['id']);

        if ($in['submitType'] == 'Submit') {
            set_time_limit(5);
            $this->_saveRequest();
            $this->_startApproval();
            $this->redirect('/requests');
        } else if ($in['submitType'] == 'Return to Edit') {
            $this->redirect('/learningoutcomes/edit/index/id/' . $in['id']);
        } else if ($in['submitType'] == 'Save Changes') {
            $this->_saveRequest();
            $this->redirect('/learningoutcomes/view/index/id/' . $session->request->getId());
        } else if ($in['submitType'] == 'Save for Later Submission') {
            $this->_saveForLater();
            $this->redirect('/requests');
        } else if ($in['submitType'] == 'Abandon Changes') {
            $this->redirect('/requests');
        } else if ($in['submitType'] == 'Cancel Request') {
            $this->redirect('/requests');
        }
        exit;
    }

    protected function _saveRequest()
    {
        $in = $this->getAllParams();
        $session = new Zend_Session_Namespace('Edit Request ' . $in['id']);

        if ($session->currentSavedRequestId !== null) {
            $id = $session->currentSavedRequestId;
            $user = Auth_UserModel::findCurrentUser();

            $savedRequestRegistry = RegistryModel::findByNamespaceAndKey($user->getId(), 'savedRequests');
            $savedRequests = $savedRequestRegistry->getData();
            unset($savedRequests[$id]);
            $savedRequestRegistry->setData($savedRequests);
            $collection = new Unl_Model_Collection('RegistryModel');
            $collection[] = $savedRequestRegistry;
            RegistryModel::save($collection);
            unset($session->currentSavedRequestId);
        }

        Requests_RequestModel::save($session->request);
        $session->learningOutcome->setRequest($session->request);
        LearningOutcomes_LearningOutcomeModel::save($session->learningOutcome);
    }

    protected function _startApproval()
    {
        $in = $this->getAllParams();
        $session = new Zend_Session_Namespace('Edit Request ' . $in['id']);
        Requests_ApprovalChainModel::consider($session->request);
    }

    public function loadAction()
    {
        $in = $this->getRequest()->getParams();

        $tempId = hash('md5', openssl_random_pseudo_bytes(16));
        $session = new Zend_Session_Namespace('Edit Request ' . $tempId);

        if ($in['sessionId'] !== null) {
            $id = $in['sessionId'];
            $user = Auth_UserModel::findCurrentUser();
            $savedRequests = RegistryModel::findByNamespaceAndKey($user->getId(), 'savedRequests')->getData();
            $request = $savedRequests[$id]['request'];
            $learningOutcome = $savedRequests[$id]['learningOutcome'];
            $previousLearningOutcome = NULL;
            /*
            if ($this->_isSavedRequestStale($request, $course)) {
                $controllerSession = new Zend_Session_Namespace(__CLASS__);
                $controllerSession->errorMessage = 'Unfortunately another request modifying this course has been submitted since you saved your request.  You will need to create a new request to continue.';
                $this->_redirect('/courses/edit/error');
                exit;
            }
            */
            $session->currentSavedRequestId = $id;
        } else {
            $id = $in['id'];
            $request = Requests_RequestModel::find($id);
            $learningOutcome = LearningOutcomes_LearningOutcomeModel::findLatestOfRequest($request);
            $previousLearningOutcome = LearningOutcomes_LearningOutcomeModel::findParentOfRequest($request);
            $learningOutcome = clone $learningOutcome;
            unset($session->currentSavedRequestId);
        }

        $session->request = $request;
        $session->learningOutcome = $learningOutcome;
        $session->previousLearningOutcome = $previousLearningOutcome;

        $this->_redirect('/learningoutcomes/edit/index/id/' . $tempId);
    }

    protected function _saveForLater()
    {
        $in = $this->getAllParams();
        $session = new Zend_Session_Namespace('Edit Request ' . $in['id']);
        $user = Auth_UserModel::findCurrentUser();
        $savedRequestRegistry = RegistryModel::findByNamespaceAndKey($user->getId(), 'savedRequests');
        $savedRequests = $savedRequestRegistry->getData();

        if (!Unl_Util::isArray($savedRequests)) {
            $savedRequests = array();
        }
        $newSavedRequest = array(
            'request'         => $session->request,
            'learningOutcome' => $session->learningOutcome,
        );

        if ($session->currentSavedRequestId !== null) {
            $id = $session->currentSavedRequestId;
            $savedRequests[$id] = $newSavedRequest;
        } else {
            $savedRequests[] = $newSavedRequest;
        }

        $savedRequestRegistry->setData($savedRequests);
        $collection = new Unl_Model_Collection('RegistryModel');
        $collection[] = $savedRequestRegistry;
        RegistryModel::save($collection);
    }
}
