<?php

class LearningOutcomes_NewController extends Creq_Controller_Action
{
    public function indexAction()
    {
        $this->view->messages = $this->_helper->getHelper('FlashMessenger')->getMessages();
        $this->view->majors = Bulletin_UtilityModel::getMajors();
    }

    public function createAction()
    {
        $in = $this->getAllParams();

        $activeRequests = LearningOutcomes_LearningOutcomeModel::findActiveRequestByMajorId($in['major']);
        foreach ($activeRequests as $activeRequest) {
            $href = $this->view->baseUrl('/requests/view/index/id/' . $activeRequest->getId());
            $this->_helper->getHelper('FlashMessenger')->addMessage(
                "There is already an <a href=\"$href\">active request</a> for that college/major"
            );
            $this->redirect('/learningoutcomes/new');
        }

        $request = Requests_RequestModel::fetchNew();
        $request->setModule('learningoutcomes');
        $user = Auth_UserModel::findCurrentUser();
        $request->setOwner($user);
        $request->setJustification('--None Required--');

        $learningOutcome = LearningOutcomes_LearningOutcomeModel::findByMajorId($in['major']);
        if (!$learningOutcome) {
            $learningOutcome = LearningOutcomes_LearningOutcomeModel::fetchNew();
            $learningOutcome->setMajorId($in['major']);
            $previousLearningOutcome = NULL;
            $request->setType('NewLearningOutcome');
        } else {
            $previousLearningOutcome = LearningOutcomes_LearningOutcomeModel::findByLearningOutcomeId($learningOutcome->getLearningOutcomeId());
            $learningOutcome = clone $learningOutcome;
            $request->setType('ChangeLearningOutcome');
        }

        $id = bin2hex(openssl_random_pseudo_bytes('16'));
        $session = new Zend_Session_Namespace('Edit Request ' . $id);
        $session->learningOutcome = $learningOutcome;
        $session->previousLearningOutcome = $previousLearningOutcome;
        $session->request = $request;
        unset($session->currentSavedRequestId);

        $this->redirect('/learningoutcomes/edit/index/id/' . $id);
    }
}
