<?php

require_once APPLICATION_PATH . '/modules/requests/controllers/ViewController.php';

class LearningOutcomes_ViewController extends Requests_ViewController
{
    public function indexAction()
    {
        $this->_commonIndexAction();

        $request = $this->view->request;

        $in = $this->getAllParams();
        if ($in['type'] == 'session' && isset($in['id']) && $in['id']) {
            $session = new Zend_Session_Namespace('Edit Request ' . $in['id']);
            $learningOutcome = $session->learningOutcome;
            $previousLearningOutcome = $session->previousLearningOutcome;

            if ($request->getId()) {
                $this->view->initialRequest = false;
            } else {
                $this->view->initialRequest = true;
            }

            $this->view->preview = true;
        } else {
            $learningOutcome = LearningOutcomes_LearningOutcomeModel::findLatestOfRequest($request);
            if (in_array($request->getType(), array('ChangeLearningOutcome'))) {
                $previousLearningOutcome = LearningOutcomes_LearningOutcomeModel::findParentOfRequest($request);
            }
            $this->view->initialRequest = false;
            $this->view->preview = false;
        }

        $this->view->request = $request;
        $this->view->id = $in['id'];
        $this->view->isRequestValid = $request->isValid();
        $this->view->learningOutcome = $learningOutcome;
        $this->view->previousLearningOutcome = $previousLearningOutcome;
        $this->view->planCourses = $planCourses;
    }

    public function feedAction()
    {
        $learningOutcomes = array();

        foreach (LearningOutcomes_LearningOutcomeModel::findAllActive() as $learningOutcome) {
            $record = array();
            $record['creq-id'] = $learningOutcome->getLearningOutcomeId();
            $record['major'] = $learningOutcome->getMajor();
            foreach ($learningOutcome->getConcentrations() as $concentrationId => $concentration) {
                foreach (LearningOutcomes_LearningOutcomeModel::$outcomes as $outcomeId => $outcome) {
                    $details = $learningOutcome->getDetail($concentration, $outcomeId);
                    $record['concentrations'][$concentration][$outcomeId] = $details;
                }
            }
            $learningOutcomes[] = $record;
        }

        header('Content-type: application/json');
        echo json_encode($learningOutcomes);
        exit;
    }

    public function listAction()
    {
        $this->view->learningOutcomes = LearningOutcomes_LearningOutcomeModel::findAllActive();
    }

    public function publicAction()
    {
        $learningOutcome = LearningOutcomes_LearningOutcomeModel::findByLearningOutcomeId($this->getParam('id'));
        $requests = LearningOutcomes_LearningOutcomeModel::findAllRequestsForMajor($learningOutcome);
        $requestLearningOutcomes = LearningOutcomes_LearningOutcomeModel::findLatestOfRequest($requests);
        $requestParentLearningOutcomes = LearningOutcomes_LearningOutcomeModel::findParentOfRequest($requests);

        $this->view->learningOutcome = $learningOutcome;
        $this->view->requests = $requests;
        $this->view->requestLearningOutcomes = $requestLearningOutcomes;
        $this->view->requestParentLearningOutcomes = $requestParentLearningOutcomes;
    }
}
