<?php

class LearningOutcomes_UtilityModel implements Creq_Model_UtilityInterface
{
    static public function loadAdditionalData(&$data)
    {
        $requests = array();
        foreach ($data as $i => $record) {
            $requests[$i] = $record['request'];
        }

        $requestPlans = LearningOutcomes_LearningOutcomeModel::findLatestOfRequest($requests);

        foreach ($data as $i => &$record) {
            $record['extra']['Major'] = $requestPlans[$record['request']->getId()]->getMajor();
            $record['extra']['College'] = $requestPlans[$record['request']->getId()]->getCollege();
        }
        unset($record);
    }

    static public function getCollegesForRequests($requests)
    {
        $requestColleges = array();

        $requestParentLos = LearningOutcomes_LearningOutcomeModel::findParentOfRequest($requests);
        $requestCurrentLos = LearningOutcomes_LearningOutcomeModel::findLatestOfRequest($requests);
        foreach ($requests as $request) {
            $lo = $requestParentLos[$request->getId()];
            if (!$lo) {
                $lo = $requestCurrentLos[$request->getId()];
            }
            $requestColleges[$request->getId()] = $lo->getCollege();
        }

        return $requestColleges;
    }

    static public function getMajorsForRequests($requests)
    {
        $requestMajors = array();

        $requestParentLos = LearningOutcomes_LearningOutcomeModel::findParentOfRequest($requests);
        $requestCurrentLos = LearningOutcomes_LearningOutcomeModel::findLatestOfRequest($requests);
        foreach ($requests as $request) {
            $lo = $requestParentLos[$request->getId()];
            if (!$lo) {
                $lo = $requestCurrentLos[$request->getId()];
            }
            $requestMajors[$request->getId()] = $lo->getMajor();
        }

        return $requestMajors;
    }
}
