<?php

class Requests_EditController extends Creq_Controller_Action 
{
	public function loadAction()
	{
		$in = $this->getRequest()->getParams();
        $roleId = $in['role'];
        $list = $in['list'];
        
		if ($in['sessionId'] !== null) {
			$id = $in['sessionId'];
			$session = new Zend_Session_Namespace('Edit Request');
            $user = Auth_UserModel::findCurrentUser();
            $savedRequests = RegistryModel::findByNamespaceAndKey($user->getId(), 'savedRequests')->getData();
			$request = $savedRequests[$id]['request'];
	        $module = $request->getModule();
	        $redirectUrl = '/' . $module . '/edit/load/sessionId/' . $id;
		} else {
			$id = $in['id'];
			$request = Requests_RequestModel::find($id);
	        $module = $request->getModule();
	        $redirectUrl = '/' . $module . '/edit/load/id/' . $id;
		}
	
        $session = new Zend_Session_Namespace('My Requests');
        if ($roleId) {
            $session->lastRoleId = $roleId;
        }
        if ($list) {
            $session->lastList = $list;
        }
        
        $this->_redirect($redirectUrl);
	}
	
	public function deleteSavedAction()
	{
		$id = $this->getRequest()->getParam('id');
		$user = Auth_UserModel::findCurrentUser();
        $savedRequestRegistry = RegistryModel::findByNamespaceAndKey($user->getId(), 'savedRequests');
        $savedRequests = $savedRequestRegistry->getData();
        unset($savedRequests[$id]);
        $savedRequestRegistry->setData($savedRequests);
        $collection = new Unl_Model_Collection('RegistryModel');
        $collection[] = $savedRequestRegistry;
        RegistryModel::save($collection);
		
		
		$this->_redirect('/requests');
	}
}