<?php

class Requests_WithdrawnController extends Creq_Controller_Action
{
    public function preDispatch()
    {
        $user = Auth_UserModel::findCurrentUser();
        $roles = Auth_GroupModel::findByUser($user);
        if (!in_array(1, $roles->getId())) {
            throw new Exception('You must be logged in to view this page.');
        }
    }
    
    public function indexAction()
    {
        // @TODO: Make this dynamically load module data.

        $requests = Requests_RequestModel::findByState('Withdraw');
        $moduleRequests = array(
            'courses'       => new Unl_Model_Collection('Requests_RequestModel'),
            'bulletin'      => new Unl_Model_Collection('Requests_RequestModel'),
            'fouryearplans' => new Unl_Model_Collection('Requests_RequestModel'),
        );
        foreach ($requests as $request) {
            $moduleRequests[$request->getModule()][$request->getId()] = $request;
        }
        $requestCourses = Courses_CourseModel::findLatestOfRequest($moduleRequests['courses']);
        $requestBulletins = Bulletin_SectionModel::findWithRequest($moduleRequests['bulletin']);
        $requestFyps = FourYearPlans_FourYearPlanModel::findLatestOfRequest($moduleRequests['fouryearplans']);
        
        $this->view->moduleRequests = $moduleRequests;
        $this->view->requestCourses = $requestCourses;
        $this->view->requestBulletins = $requestBulletins;
        $this->view->requestFyps = $requestFyps;
    }
}
