<?php

class Requests_FileModel extends Unl_Model
{
    static public function find($id)
    {
        $db = Zend_Registry::get('db');
        
        $select = new Zend_Db_Select($db);
        $select->from(array('f' => 'creqFiles'));
        if (Unl_Util::isArray($id)) {
            if (count($id) == 0) {
                return new Unl_Model_Collection(__CLASS__);
            }
            $select->where('f.fileId IN(?)', $id);
        } else {
            $select->where('f.fileId = ?', $id);
        }
        
        $records = $db->query($select)->fetchAll();
        $objects = new Unl_Model_Collection(__CLASS__);
        foreach ($records as $record) {
            $object = Unl_Model_Registry::getInstance()->getOrAdd(new self($record));
            $objectId = $object->getId();
            $objects[$objectId] = $object;
        }
        
        foreach ($objects as $object) {
        	if ($object->_data['data'] == '') {
        		$object->_data['data'] = self::_loadFileFromDisk($object->_data['hash']);
        	}
        }
        
        if (Unl_Util::isArray($id)) {
            return $objects;
        } else {
            return $objects->pop();
        }
    }

    
    public function getId()
    {
    	return $this->_data['fileId'];
    }
    
    public function getData()
    {
    	return $this->_data['data'];
    }
    
    public function getTitle()
    {
    	return $this->_data['title'];
    }
    
    public function getMimeType()
    {
    	return $this->_data['mimeType'];
    }
    
    static protected function _loadFileFromDisk($hash)
    {
        $path = APPLICATION_PATH
              . DIRECTORY_SEPARATOR
              . 'uploads'
              . DIRECTORY_SEPARATOR
              . substr($hash, 0, 1)
              . DIRECTORY_SEPARATOR
              . substr($hash, 1, 2);

        @mkdir($path, 0755, true);
        $data = file_get_contents($path . DIRECTORY_SEPARATOR . $hash);
        return $data;
    }
}
