function myCustomCleanup(type, value) {
    switch (type) {
        case "get_from_editor":
            value = value.replace(/&lt;![ \r\n\t]*(--([^\-]|[\r\n]|-[^\-])*--[ \r\n\t]*)&gt;/gi, "");
            value = value.replace(/<![ \r\n\t]*(--([^\-]|[\r\n]|-[^\-])*--[ \r\n\t]*)>/gi, "");
            // Do custom cleanup code here
            break;
    }

    return value;
}

WDN.jQuery(function() {
    tinymce.PluginManager.load('ice', WDN.jQuery('html').data('baseUrl') + '/ice/lib/tinymce/jscripts/tiny_mce/plugins/ice/editor_plugin.js');

    tinyMCE.init({
        mode    : "textareas",
        theme   : "advanced",
        plugins : "spellchecker, table, ice",
        editor_selector : "mceEditor",
        entity_encoding : "raw",
        theme_advanced_toolbar_location : "top",
        theme_advanced_toolbar_align    : "left",
        theme_advanced_buttons1 : "bold, italic, underline, sub, sup, indent, outdent, justifyleft, justifyright, spellchecker, formatselect, styleselect", //, crosslistings",
        theme_advanced_buttons2 : "numlist, bullist, tablecontrols",
        theme_advanced_buttons3 : "",
        theme_advanced_statusbar_location : "bottom",
        theme_advanced_styles : ""
                              + "Asterisk=asterisk;"
                              + "Basic Text Bold=basic-text-bold;"
                              + "Basic Text Italic=basic-text-ital;"
                              + "Basic Text=basic-text;"
                              + "Bullet 1=bullet-1;"
                              + "Bullet 2=bullet-2;"
                              + "Bullet 3=bullet-3;"
                              + "College Name=college-name;"
                              + "College Name=college-name;"
                              + "Context Box H1=context-box-h-1;"
                              + "Context Box MP=context-box-m-p;"
                              + "Endorsement Title=endorsement-title;"
                              + "Endorsements=endorsements;"
                              + "Faculty List Bold=faculty-list-bold;"
                              + "Faculty List=faculty-list;"
                              + "Header Paragraph Title=header-paragraph-title;"
                              + "Leader=leader;"
                              + "List Bold=list-bold;"
                              + "List Indent=list-indent;"
                              + "List Italic=list-ital;"
                              + "List=list;"
                              + "Major Name=major-name;"
                              + "Numbered List 2=numbered-list-2;"
                              + "Numbered List 3=numbered-list-3;"
                              + "Numbered List=numbered-list;"
                              + "Quick Points=quick-points;"
                              + "Requirement Bold=requirement-bold;"
                              + "Requirement Description=req_desc;"
                              + "Requirement Hours=requirement-hours;"
                              + "Requirement Italic=requirement-ital;"
                              + "Requirement Section 1=requirement-sec-1;"
                              + "Requirement Section 1=requirement-sec-1;"
                              + "Requirement Section 2=requirement-sec-2;"
                              + "Requirement Section 3 Leader=requirement-sec-3-ledr;"
                              + "Requirement Section 3 Note=requirement-sec-3-note;"
                              + "Requirement Section 3 Note=requirement-sec-3-note;"
                              + "Requirement Section 3=requirement-sec-3;"
                              + "Requirement Section 4 Leader=requirement-sec-4-ledr;"
                              + "Requirement Section 4=requirement-sec-4;"
                              + "Requirement Underline=requirement-underline;"
                              + "Requirement Value=req_value;"
                              + "Section 1=section-1;"
                              + "Section 2=section-2;"
                              + "Section 3=section-3;"
                              + "Superscript=superscript;"
                              + "Title 1=title-1;"
                              + "Title 2=title-2;"
                              + "Title 3=title-3;"
                              ,
        noneditable_noneditable_class : "mceNonEditable",
        valid_elements : ""
                       + "@[class|style],"
                       + "p,"
                       + "div,"
                       + "span,"
                       + "-strong/-b,"
                       + "-em/-i,"
                       + "-sub,"
                       + "-sup,"
                       + "br,"
                       + "table,"
                       + "thead,"
                       + "tbody,"
                       + "tr,"
                       + "td,"
                       + "ul,"
                       + "li,"
                       + "del,"
                       + "ins"
                       + "",
        cleanup_callback : "myCustomCleanup",
        ice: {
            user: {name: WDN.jQuery('html').data('user').fullName, id: WDN.jQuery('html').data('user').id},
            preserveOnPaste: 'strong,b,em,i,sub,sup,br,p',
            insertTag: 'ins',
            deleteTag: 'del',
            afterInit: function() {
                // hack to get focus back from ICE plugin after it
                // rudely scrolls to a random text area
                window.scrollTo(0, 0);
                WDN.jQuery('#q').focus().blur();
            },
        },
        init_instance_callback: function(editor) {
            editor.execCommand('ice_toggleshowchanges');
        },
    });
});
