WDN.jQuery(function() {
    WDN.loadCSS(WDN.getTemplateFilePath('scripts/plugins/ui/jquery-ui.css'));
    WDN.loadJS(WDN.getTemplateFilePath('scripts/plugins/ui/jQuery.ui.js'), function() {

        WDN.jQuery('.add_record_button').click(handleAddRecord);
        WDN.jQuery('.remove_record_button').click(handleRemoveRecord);

        WDN.jQuery('#subject').change(handleChangeHomeSubject);
        WDN.jQuery('#courseNumber').change(handleChangeHomeCourseNumber);
        WDN.jQuery('#courseLetter').change(handleChangeHomeCourseLetter);

        if (document.getElementById('aceOutcomeList')) {
            var outcomesChecked = 0;

            WDN.jQuery('#aceOutcomeList .enableItem').each(function(index) {
                WDN.jQuery(this).change(handleOutcomeToggled);
                WDN.jQuery(this).click(handleOutcomeClicked);
                if (this.checked) {
                    outcomesChecked++;
                }
            });

            if (outcomesChecked >= 2) {
                WDN.jQuery('#aceOutcomeList .enableItem').each(function(index) {
                    this.disabled = !this.checked;
                });
            }

            WDN.jQuery('#aceOutcomeList .changeAnswer').each(function() {
                WDN.jQuery(this).change(handleChangeAnswerToggle);
            });
        }

        if (document.getElementById('aceReinforcementList')) {
            var reinforcementsChecked = 0;

            WDN.jQuery('#aceReinforcementList .enableItem').each(function(index) {
                WDN.jQuery(this).change(handleReinforcementToggled);
                WDN.jQuery(this).click(handleReinforcementClicked);
                if (this.checked) {
                    reinforcementsChecked++;
                }
            });

            WDN.jQuery('#aceReinforcementList .changeAnswer').each(function() {
                WDN.jQuery(this).change(handleChangeAnswerToggle);
            });
        }

        WDN.jQuery('.courseCodeInput').change(handleCourseCodeInputChange);
        WDN.jQuery('.courseSubjectInput').change(handleChangeCourseSubject);
        WDN.jQuery('.courseNumberInput').change(handleChangeCourseNumber);
        WDN.jQuery('.courseLetterInput').change(handleChangeCourseLetter);
        WDN.jQuery('.activitySelect').change(handleChangeActivity);
        WDN.jQuery('#credits input').change(handleChangeCredits);
        WDN.jQuery('.dfRemovalRadio').change(handleChangeDfRemoval);

        WDN.jQuery('#dialog').dialog({
            autoOpen: false,
            modal: true,
            beforeclose: dequeuePopup
        });

        WDN.jQuery('[target=helpWindow]').click(helpLinkClicked);
        WDN.jQuery('#editRequestForm').submit(handleFormSubmit);

        WDN.jQuery('#ace-recertify-developPlan-na').change(function() {
            if (this.checked) {
                WDN.jQuery('#ace-recertify-developPlan').css('display', 'none');
            } else {
                WDN.jQuery('#ace-recertify-developPlan').css('display', 'inline');
            }
        })

        // Fix for IE :-(
        WDN.jQuery('input[type=checkbox]').click(function() {
            this.blur();
        });

        // Add the ability to toggle TinyMCE for admin users.
        if (WDN.jQuery('html').data('user').useToggleEditor) {
            WDN.jQuery('.mceEditor').each(function() {
                WDN.jQuery(this).parent().append('<div><button class="editor-toggle" data-enabled="yes" data-editor-id="' + this.id + '">Toggle Editor</button></div>');
            });
            WDN.jQuery('#maincontent').on('click', '.editor-toggle', function() {
                var link = WDN.jQuery(this);
                if (link.data('enabled') == 'yes') {
                    tinyMCE.execCommand('mceRemoveControl', false, link.data('editor-id'));
                    link.data('enabled', 'no');
                } else {
                    tinyMCE.execCommand('mceAddControl',    false, link.data('editor-id'));
                    link.data('enabled', 'yes');
                }
                return false;
            });
        }

        updateRelatedCourses();
    });
});

function helpLinkClicked()
{
    var href = this.href;
    var helpWindow = WDN.jQuery(document).attr('helpWindow');
    if (!helpWindow || helpWindow.closed) {
        helpWindow = window.open(href, 'helpWindow', "height=600,width=1000,scrollbars=yes,alwaysRaised=yes")
    } else {
        helpWindow.location = href;
    }
    helpWindow.focus();

    WDN.jQuery(document).attr('helpWindow', helpWindow);
    return false;
}

function queuePopup(htmlContent, buttons, helpAnchor)
{
    var dialog = WDN.jQuery('#dialog');
    var queue = dialog.data('queue');
    
    if (!dialog.data('queue')) {
        queue = [];
    }
    
    if (helpAnchor) {
        htmlContent = '<div>' + htmlContent + '</div>'
                    + '<div><a href="' + baseUrl + '/courses/edit/help#' + helpAnchor + '" target="helpWindow">Policy Details</a></div>';
    }
    
    queue.push({htmlContent: htmlContent, buttons: buttons});
    dialog.data('queue', queue);
    
    if (!dialog.dialog('isOpen')) {
        dequeuePopup();
    }
}

function dequeuePopup()
{   
    var dialog = WDN.jQuery('#dialog');
    var queue = dialog.data('queue');
    
    if (queue.length == 0) { 
        return true;
    }
    var args = queue.shift();
    dialog.data('queue', queue);
    
    dialog.html(args.htmlContent);
    dialog.dialog('option', 'buttons', args.buttons);
    dialog.dialog('open');

    WDN.jQuery('[target=helpWindow]').click(helpLinkClicked);
    
    return false;
}

function handleAddRecord()
{
    var currentTR = this.parentNode.parentNode;
    var currentTable = currentTR.parentNode;
    var hiddenTR = currentTR.previousSibling;
    if (hiddenTR.nodeName == '#text') {
        hiddenTR = hiddenTR.previousSibling;
    }
    var currentIndex = currentTable.getElementsByTagName('tr').length - 2 + 1000;

    var newNode = hiddenTR.cloneNode(true);
    for(var i = 0; i < newNode.childNodes.length; i++) {
        var inputElement = newNode.childNodes[i].childNodes[1];
        if (!inputElement || (inputElement.nodeName != 'INPUT' && inputElement.nodeName != 'SELECT')) {
            inputElement = newNode.childNodes[i].childNodes[0];
        }
        if (!inputElement || (inputElement.nodeName != 'INPUT' && inputElement.nodeName != 'SELECT')) {
            continue;
        }

        inputElement.disabled = false;
        var keyIndex = inputElement.name.indexOf('__key__');
        if (keyIndex > 0) {
            inputElement.name = inputElement.name.substr(0, keyIndex) + '-' + currentIndex + inputElement.name.substr(keyIndex + 7);
        }
    }

    var linkNode = newNode.childNodes[newNode.childNodes.length - 2].childNodes[1];
    if (linkNode.nodeName != 'A') {
        linkNode = newNode.childNodes[newNode.childNodes.length - 1].childNodes[0];
    }
    linkNode.onclick = handleRemoveRecord;
    currentTable.insertBefore(newNode, hiddenTR);
    newNode.className = '';

    if(this.id.substr(0, 17) == 'add_tie_in_button') {
        var courseId = this.id.substr(18).split('_');
        var subjectCode = courseId[0];
        var courseNumber = courseId[1];
        var courseLetter = courseId[2];
        var removeButtonId = 'remove' + this.id.substr(3);

        courseNumber = '8' + courseNumber.substr(1);

        this.style.display = 'none';
        newNode.childNodes[3].childNodes[1].value = subjectCode;
        newNode.childNodes[3].childNodes[1].readOnly = true;
        newNode.childNodes[7].childNodes[1].value = courseNumber;
        newNode.childNodes[7].childNodes[1].readOnly = true;
        newNode.childNodes[11].childNodes[1].value = courseLetter;
        newNode.childNodes[11].childNodes[1].readOnly = true;
        newNode.childNodes[13].childNodes[1].value = 'grad tie-in';
        newNode.childNodes[13].childNodes[1].readOnly = true;
        newNode.childNodes[15].childNodes[1].id = removeButtonId;
        newNode.className = 'grad_tie_in_row';
        
        if (WDN.jQuery('#courseNumber').val() < 400) {
            queuePopup(
                '"800" grad courses cannot be tied to 100, 200, or 300 undergraduate courses',
                {
                    'Reset':  function() {
                        WDN.jQuery(newNode.childNodes[15].childNodes[1]).click();
                        WDN.jQuery(this).dialog('close');
                    },
                    'Ignore': function() {
                        WDN.jQuery(this).dialog('close');
                    }
                },
                'crosslistings'
            );
        }
    }


    WDN.jQuery('.courseCodeInput').change(handleCourseCodeInputChange);
    WDN.jQuery('.courseSubjectInput').change(handleChangeCourseSubject);
    WDN.jQuery('.courseNumberInput').change(handleChangeCourseNumber);
    WDN.jQuery('.courseLetterInput').change(handleChangeCourseLetter);
    WDN.jQuery('.activitySelect').change(handleChangeActivity);
    
    return false;
}

function handleRemoveRecord()
{
    // If this is a crosslisting record.
    if (WDN.jQuery(this).parents('#crosslistingsTable').length > 0) {
        var parentFieldset = WDN.jQuery(this).parent().parent();
        var subject = parentFieldset.find('.courseSubjectInput').val();
        var courseNumber = parentFieldset.find('.courseNumberInput').val();
        var courseLetter = parentFieldset.find('.courseLetterInput').val();
        
        var key = subject  + ':' + courseNumber  + ':' + courseLetter;
        WDN.jQuery('.courseCodeGroupCrosslistingSelect option[value="' + key + '"]').remove();
    }
    
    
    var currentTR = this.parentNode.parentNode;
    var currentTable = currentTR.parentNode;

    if(this.id.substr(0, 20) == 'remove_tie_in_button') {
        var addButtonId = 'add' + this.id.substr(6);
        document.getElementById(addButtonId).style.display = 'inline';
    }

    currentTable.removeChild(currentTR);

    return false;
}

function handleChangeHomeSubject()
{
    var previousSubject = this.previousValue || this.defaultValue;
    if (this.previousValue != this.value) {
        this.previousValue = this.value;
    }

    WDN.jQuery('.grad_tie_in_row .courseSubjectInput'). each(function() {
        this.value = this.value.replace(previousSubject, WDN.jQuery('#subject').val());
        WDN.jQuery(this).change();
    });
}

function handleChangeHomeCourseNumber()
{
    var gradNumber = 800 + (this.value % 100);
    var gradTieInRows = getElementsByClass('grad_tie_in_row');
    WDN.jQuery('.grad_tie_in_row .courseNumberInput'). each(function() {
        this.value = gradNumber;
        WDN.jQuery(this).change();
    });
}

function handleChangeHomeCourseLetter()
{
    var gradLetter = this.value;
    var gradTieInRows = getElementsByClass('grad_tie_in_row');
    WDN.jQuery('.grad_tie_in_row .courseLetterInput'). each(function() {
        this.value = gradLetter;
        WDN.jQuery(this).change();
    });
}

function updateCourseGroupCrosslistingList(previous, updated) {
    if ((previous.subject == '' || previous.courseNumber == '') && (updated.subject != '' && updated.courseNumber != '')) {
        WDN.jQuery('.courseCodeGroupCrosslistingSelect').each(function() {
            var newOption = WDN.jQuery('<option />');
            newOption.val(updated.subject + ':' + updated.courseNumber + ':' + updated.courseLetter);
            newOption.attr('label', updated.subject + ' ' + updated.courseNumber + updated.courseLetter);
            newOption.text(newOption.attr('label'));
            WDN.jQuery(this).append(newOption);
        });
    } else if (updated.subject == '' || updated.courseNumber == '' && (previous.subject != '' && previous.courseNumber != '')) {
        var key = previous.subject  + ':' + previous.courseNumber  + ':' + previous.courseLetter;
        WDN.jQuery('.courseCodeGroupCrosslistingSelect option[value="' + key + '"]').remove();
    } else if (previous.subject != '' && previous.courseNumber != '' && updated.subject != '' && updated.courseNumber != ''){
        WDN.jQuery('.courseCodeGroupCrosslistingSelect option').each(function() {
            this.label = this.label.replace(
                previous.subject + ' ' + previous.courseNumber + previous.courseLetter,
                updated.subject  + ' ' + updated.courseNumber  + updated.courseLetter
            );
    
            this.value = this.value.replace(
                previous.subject + ':' + previous.courseNumber + ':' + previous.courseLetter,
                updated.subject  + ':' + updated.courseNumber  + ':' + updated.courseLetter
            );
            
            this.text = this.label;
        });
    }
}

function handleChangeCourseSubject()
{
    // Update the list of course codes in the course group section
    var previousSubject = this.previousValue || this.defaultValue;
    if (this.previousValue != this.value) {
        this.previousValue = this.value;
    }
    
    var parentFieldset = WDN.jQuery(this).parent().parent();
    
    updateCourseGroupCrosslistingList({
        subject:      previousSubject,
        courseNumber: parentFieldset.find('.courseNumberInput').val(),
        courseLetter: parentFieldset.find('.courseLetterInput').val()
    }, {
        subject:      parentFieldset.find('.courseSubjectInput').val(),
        courseNumber: parentFieldset.find('.courseNumberInput').val(),
        courseLetter: parentFieldset.find('.courseLetterInput').val()
    });
}

function handleChangeCourseNumber()
{
    var courseNumber = this.value;
    var message = '';
    
    switch (courseNumber % 100) {
        case 90:
        case 93:
            message = 'Courses with _90 or _93 are reserved for workshops/seminars.';
            break;
            
        case 91:
        case 92:
            message = 'Courses with _91 or _92 are reserved for special topis/seminars/tours.';
            break;
            
        case 94:
            message = 'Courses with _94 are reserved for independent study.';
            break;
            
        case 95:
            message = 'Courses with _95 are reserved for internships.';
            break;
            
        case 96:
            message = 'Courses with _96 are reserved for independent study.';
            break;
            
        case 97:
            message = 'Courses with _97 are reserved for practicums (field type courses).';
            break;
            
        case 98:
            message = 'Courses with _98 are reserved for research.';
            break;
    }
    
    switch (courseNumber) {
        case 899:
            message = 'Courses with 899 are reserved for graduate (Masters) theses.';
            break;
            
        case 999:
            message = 'Courses with 999 are reserved for graduate (Doctorate) courses.';
            break;
    }
    
    var homeCourseNumber = WDN.jQuery('#courseNumber').val();
    if (homeCourseNumber % 100 != courseNumber % 100) {
        message = 'The last two digits of the course number should be the same as the home department course number.'
    }
    
    if (message) {
        var courseNumberNode = this;
        queuePopup(
            message,
            {
                'Reset':  function() {
                    courseNumberNode.value = courseNumberNode.defaultValue;
                    WDN.jQuery(this).dialog('close');
                },
                'Ignore': function() {
                    WDN.jQuery(this).dialog('close');
                }
            },
            'courseNumbering'
        );
    }
    
    
    // Update the list of course codes in the course group section
    var previousCourseNumber = this.previousValue || this.defaultValue;
    if (this.previousValue != this.value) {
        this.previousValue = this.value;
    }
    
    var parentFieldset = WDN.jQuery(this).parent().parent();
    
    updateCourseGroupCrosslistingList({
        subject:      parentFieldset.find('.courseSubjectInput').val(),
        courseNumber: previousCourseNumber,
        courseLetter: parentFieldset.find('.courseLetterInput').val()
    }, {
        subject:      parentFieldset.find('.courseSubjectInput').val(),
        courseNumber: parentFieldset.find('.courseNumberInput').val(),
        courseLetter: parentFieldset.find('.courseLetterInput').val()
    });
}

function handleChangeCourseLetter()
{
    var courseLetter = this.value;
    var message = '';
    
    switch (courseLetter.toUpperCase()) {
		case 'L':
			message = '"L" represents a laboratory class.';
			break;
	
		case 'H':
			message = '"H" represents an honors class.';
			break;
	
		case 'G':
			message = '"G" represents professional courses for graduate credit.';
			break;

		case 'C':
		case 'D':
		case 'F':
		case 'I':
		case 'O':
		case 'S':
		case 'Z':
			message = '"C, D, F, I, O, S and Z" cannot be used as suffixes.';
			break;
    }
    
    if (message) {
        var courseLetterNode = this;
        queuePopup(
            message,
            {
                'Reset':  function() {
                    courseLetterNode.value = courseLetterNode.defaultValue;
                    WDN.jQuery(this).dialog('close');
                },
                'Ignore': function() {
                    WDN.jQuery(this).dialog('close');
                }
            },
            'courseNumbering'
        );
    }
    
    // Update the list of course codes in the course group section
    var previousCourseLetter = this.previousValue || this.defaultValue;
    if (this.previousValue != this.value) {
        this.previousValue = this.value;
    }
    
    var parentFieldset = WDN.jQuery(this).parent().parent();
    
    updateCourseGroupCrosslistingList({
        subject:      parentFieldset.find('.courseSubjectInput').val(),
        courseNumber: parentFieldset.find('.courseNumberInput').val(),
        courseLetter: previousCourseLetter
    }, {
        subject:      parentFieldset.find('.courseSubjectInput').val(),
        courseNumber: parentFieldset.find('.courseNumberInput').val(),
        courseLetter: parentFieldset.find('.courseLetterInput').val()
    });
}

function handleChangeActivity()
{
    var message = '';
    
    switch(WDN.jQuery(this).val()) {
        case 'quz':
            message = 'QUZ is always taught in conjunction with Lecture and can be taught with Lecture/Lab, Lab (for credit) or Lecture/REC.  Never taught alone.';
            break;
            
        case 'rct':
            message = 'RCT is always taught with Lecture and can be taught in conjunction with Lecture/Lab, Lab (for credit) or Lecture/QUZ.  Never taught alone.';
            break;
            
        case 'stu':
            message = 'STU is stand-alone activity.';
            break;
            
        case 'fld':
            message = 'FLD is stand-alone activity.';
            break;
            
        case 'ind':
            message = 'IND is stand-alone activity.';
            break;
    }
    
    if (message) {
        var activitySelectNode = this;
        queuePopup(
            message,
            {
                'Reset':  function() {
                    activitySelectNode.selectedIndex = 0;
                    WDN.jQuery(this).dialog('close');
                },
                'Ignore': function() {
                    WDN.jQuery(this).dialog('close');
                }
            },
            'activityType'
        );
    }
}

function handleChangeCredits()
{
    var message = '';
    var helpAnchor = 'creditAlternate';
    
    switch (this.id) {
        case 'creditsSingleValues':
            var values = this.value.split(',');
            values = WDN.jQuery.map(values, function(a) {return WDN.jQuery.trim(a);});
            if (values.inArray('0') && WDN.jQuery('#courseNumber').val() >= 100) {
                message = 'Courses with "0" credit must have a course number beginning with "0".  The only exception is Military Science.';
                helpAnchor = 'creditSingle';
            }
            if (values.length > 0 && WDN.jQuery('#courseNumber').val() % 100 >= 90) {
                message = 'Course #s with "9" as the middle number normally have credit in a range.';
                helpAnchor = 'creditRange';
            }
            WDN.jQuery.each(values, function(i, value) {
                if (value > 25) {
                    message = 'Max credit hours for undergraduate courses is 24 credit hours.';
                    helpAnchor = 'creditHoursMaxPerDegree';
                }
            });
            break;

        case 'creditsRangeMax':
            WDN.jQuery('#creditsDegreeMax').val(this.value);
            //break omitted intentionally
        case 'creditsRangeMin':
            WDN.jQuery.each(WDN.jQuery('#activities select'), function(i, value) {
                if (['lab', 'quz', 'rct'].inArray(value.value)) {
                    message = 'Credit ranges apply only to the following activities: Lec, Lab, Fld, Ind, PSI, or Stu.';
                    helpAnchor = 'creditsAlternate';
                }
            });
            
            break;
            
        case 'creditsSemesterMax':
            message = 'Max per semester is the maximum credit hours per semester that a student can take the course in a given semester.  Mini-courses and alpha sub-area courses would fall into this category.';
            helpAnchor = 'creditHoursMaxPerSemester';
            break;
            
        case 'creditsDegreeMax':
            if (WDN.jQuery('#creditsSingleValues').val() || WDN.jQuery('#creditsRangeMin').val() || WDN.jQuery('#creditsRangeMax').val()) {
                message = 'Max per degree should indicate only those courses that can be repeated more than once toward the degree.';
                helpAnchor = 'creditHoursMaxPerDegree';
            }
            break;
    }
    
    if (this.value > 24) {
        if (this.id == 'creditsDegreeMax') {
            message = 'Max repeat possible for any undergraduate course is 24 credit hours.';
            helpAnchor = 'creditHoursMaxPerDegree';
        } else {
            message = 'Max credit hours for undergraduate cuorses is 24 credit hours.';
            helpAnchor = 'creditHoursMaxPerDegree';
        }
    }
    
    if (message) {
        var creditNode = this;
        queuePopup(
            message,
            {
                'Reset':  function() {
                    creditNode.value = creditNode.defaultValue;
                    WDN.jQuery(this).dialog('close');
                },
                'Ignore': function() {
                    WDN.jQuery(this).dialog('close');
                }
            },
            helpAnchor
        );
    }
}

function handleChangeDfRemoval()
{
    var message = '';
    
    switch (this.value) {
        case 'no':
            message = 'A change in course will normally remove the grade factor from a previously "failed" course for calculating the GPA.  An exception would be if the revised course is fewer credit hours than the previous course <span style="text-decoration: underline;">OR</span> if the middle number in the course number is "9" <span style="text-decoration: underline;">OR</span> if course content has significantly changed.';
            break;
            
        case 'yes':
            if (WDN.jQuery('#courseNumber').val() % 100 >= 90) {
                message = 'Courses with "9" in the middle do not have automatic D/F Removal.';
            }
            break;
    }    
    
    if (message) {
        var dfRemovalNode = this;
        queuePopup(
            message,
            {
                'Reset':  function() {
                    dfRemovalNode.checked = false;
                    WDN.jQuery(this).dialog('close');
                },
                'Ignore': function() {
                    WDN.jQuery(this).dialog('close');
                }
            },
            'dfRemoval'
        );
    }
}

function doesCrosslistExist(subject, courseNumber, courseLetter, includeMarkedForRemoval)
{
    if (includeMarkedForRemoval === null) {
        includeMarkedForRemoval = false;
    }
    var itDoes = false;
    WDN.jQuery('#crosslistingsTable tr').each(function(index) {
        if (WDN.jQuery(this).attr('class') == 'hidden_new_record') {
            return;
        }
        var courseCodeInputs = WDN.jQuery(this).find('input.courseCodeInput');
        if (courseCodeInputs.length != 3) {
            return;
        }
        
        if (courseCodeInputs[0].value == subject &&
            courseCodeInputs[1].value == courseNumber &&
            courseCodeInputs[2].value == courseLetter &&
            (!WDN.jQuery(this).find('input:last').attr('checked') || includeMarkedForRemoval)) {
            itDoes = index;
        }
    })
    return itDoes;
}

function handleOutcomeClicked()
{
    this.blur();
}
function handleReinforcementClicked()
{
    this.blur();
}

function handleOutcomeToggled()
{
    var aceOutcomeItems = WDN.jQuery('#aceOutcomeList .enableItem');
    enforceMaximumSelectionCount(aceOutcomeItems, this, 2, true);
}

function handleReinforcementToggled()
{
    var aceReinforcementItems = WDN.jQuery('#aceReinforcementList .enableItem');
    enforceMaximumSelectionCount(aceReinforcementItems, this, 100, true);
}

function enforceMaximumSelectionCount(inputNodes, toggledInput, maxSelected, hideTextArea)
{
    var selectedCount = 0;
    for (var i = 0; i < inputNodes.length; i++) {
        if (inputNodes[i].checked) {
            selectedCount++;
        }
    }

    var isChecked = (toggledInput.checked);

    if (hideTextArea) {
        var textArea = toggledInput.parentNode.nextSibling;

        if (textArea.nodeName != 'SPAN') {
            textArea = textArea.nextSibling;
        }

        if (isChecked) {
            textArea.style.display = '';
            tinyMceEditors = textArea.getElementsByTagName('textarea');
            for (var i = 0; i < tinyMceEditors.length; i++) {
                if (tinyMceEditors[i].refreshed) {
                    continue;
                }
                tinyMCE.execCommand('mceRemoveControl', false, tinyMceEditors[i].id);
                tinyMCE.execCommand('mceAddControl', false, tinyMceEditors[i].id);
                tinyMceEditors[i].refreshed = true;
            }
        } else {
            textArea.style.display = 'none';
        }
    }

    for (var i = 0; i < inputNodes.length; i++) {
        if (isChecked && selectedCount >= maxSelected) {
            inputNodes[i].disabled = !inputNodes[i].checked;
        } else {
            inputNodes[i].disabled = false;
        }
    }
}

function handleCourseCodeInputChange()
{
    var courseCodeNodes = this.parentNode.parentNode.getElementsByTagName('input');
    var ajax = new courseCodeAvailableAjaxResponder();
    ajax.subjectNode = courseCodeNodes[0];
    ajax.courseNumberNode = courseCodeNodes[1];
    ajax.courseLetterNode = courseCodeNodes[2];
    ajax.sendRequest(ajax.getUrl());
    
    updateRelatedCourses();
}

function updateRelatedCourses()
{
    var courseCodes = {};
    var courseCodeIndex = 0;
    var courseId = WDN.jQuery('#courseId input');
    
    courseCodes['subject[' + courseCodeIndex + ']']      = courseId.eq(0).val();
    courseCodes['courseNumber[' + courseCodeIndex + ']'] = courseId.eq(1).val();
    courseCodes['courseLetter[' + courseCodeIndex + ']'] = courseId.eq(2).val();
    courseCodeIndex++;

    var originalCourseCodes = WDN.jQuery('html').data('originalCourseCodes'); 
    for (var key in originalCourseCodes) {
        courseCodes['subject[' + courseCodeIndex + ']']      = originalCourseCodes[key].subject;
        courseCodes['courseNumber[' + courseCodeIndex  +']'] = originalCourseCodes[key].courseNumber;
        courseCodes['courseLetter[' + courseCodeIndex + ']'] = originalCourseCodes[key].courseLetter;
    }
    WDN.jQuery('#crosslistingsTable tr').each(function(index, row) {
        if (row.className == 'hidden_new_record') {
            return;
        }
        var crosslisting = WDN.jQuery(row).find('input');
        if (!crosslisting.eq(0).val()) {
            return;
        }
        courseCodes['subject[' + courseCodeIndex + ']']      = crosslisting.eq(0).val();
        courseCodes['courseNumber[' + courseCodeIndex  +']'] = crosslisting.eq(1).val();
        courseCodes['courseLetter[' + courseCodeIndex + ']'] = crosslisting.eq(2).val();
        courseCodeIndex++;
    });
    WDN.jQuery('#related-courses').find('li').remove();
    WDN.jQuery('#related-majors').find('li').remove();
    
    WDN.jQuery.ajax({
        url: WDN.jQuery('html').data('baseUrl') + '/courses/edit/get-related-courses',
        data: courseCodes,
        success: function(data) {
            for (var searchedCourseCode in data) {
                for (var key in data[searchedCourseCode]) {
                    var course = data[searchedCourseCode][key];
                    if (!course.id) {
                        continue;
                    }
                    WDN.jQuery('#related-courses').append('<li>' + searchedCourseCode + ' found <a target="_new" href="' + WDN.jQuery('body').data('baseUrl') + '/courses/public-view/view/id/' + course.id + '">' + course.courseCode + '</a></li>');
                }
            }
        }
    });
    
    WDN.jQuery.ajax({
        url: WDN.jQuery('html').data('baseUrl') + '/courses/edit/get-related-majors',
        data: courseCodes,
        success: function(data) {
            for (var searchedCourseCode in data) {
                for (var key in data[searchedCourseCode]) {
                    var major = data[searchedCourseCode][key];
                    WDN.jQuery('#related-majors').append('<li>' + searchedCourseCode + ' found <br /><a target="_new" href="' + major.uri + '">' + major.name + '</a></li>');
                }
            }
        }
    })
}

function handleChangeAnswerToggle()
{
    if (this.checked) {
        WDN.jQuery(this).parent().next().css('display', 'block');
        
        var editorId = WDN.jQuery(this).parent().next().children().first().attr('id');
        tinyMCE.execCommand('mceRemoveControl', false, editorId);
        tinyMCE.execCommand('mceAddControl', false, editorId);
    } else {
        WDN.jQuery(this).parent().next().css('display', 'none');
    }

}

function handleFormSubmit()
{
    // Check to make sure the upload blackboard content checkbox is checked (if it exists on the form)
    var blackboardUploadCheckbox = WDN.jQuery('#ace-recertify-blackboardUpload');
    if (blackboardUploadCheckbox.length > 0) {
        if (!blackboardUploadCheckbox.attr('checked')) {
            queuePopup(
                'You must agree to upload the electronic student work samples into the Blackboard Content Collection folder.',
                {
                    'Ok': function() {
                        WDN.jQuery(this).dialog('close');
                    }
                }
            );
            return false;
        }
    }
}

var courseCodeAvailableAjaxResponder = AjaxClient.extend(
{
    subjectNode: null,
    courseNumberNode: null,
    courseLetterNode: null,

    processResponse: function() {
        if(this.requestObject.responseXML.childNodes[0].childNodes[0].nodeName == 'true') {
            return;
        }
        
        var message = 'The course code ' 
                    + this.subjectNode.value + ' ' + this.courseNumberNode.value + this.courseLetterNode.value
                    + ' belongs to an active course.  Click "Ignore" if you are you sure you want to continue.';
        
        /*
        if (confirm(message)) {
            return;
        }
        */
        
        var subjectNode = this.subjectNode;
        var courseNumberNode = this.courseNumberNode;
        var courseLetterNode = this.courseLetterNode;
        
        queuePopup(
            message,
            {
                'Reset':  function() {
                    subjectNode.value = subjectNode.defaultValue;
                    courseNumberNode.value = courseNumberNode.defaultValue;
                    courseLetterNode.value = courseLetterNode.defaultValue;
                    WDN.jQuery(this).dialog('close');
                },
                'Ignore': function() {
                    WDN.jQuery(this).dialog('close');
                }
            }
        );
    },

    getUrl: function() {
        return baseUrl
             + '/courses/edit/is-course-code-available'
             + '/id/' + document.formSessionId
             + '/subject/' + this.subjectNode.value
             + '/courseNumber/' + this.courseNumberNode.value
             + '/courseLetter/' + this.courseLetterNode.value;
    }
    
});
