(function() {

    WDN.jQuery(function() {

        WDN.jQuery('#refineSearchLink').on('click', function() {
            WDN.jQuery('#searchSummary').hide();
            WDN.jQuery('#searchForm').show();
        });

        hiddenDepartments = WDN.jQuery('#department').clone();
        hiddenSubjects = WDN.jQuery('#subject').clone();

        WDN.jQuery('#college, #department').on('change', handleChangeSelectHierarchy);
        handleChangeSelectHierarchy();

        WDN.jQuery('#printButton').on('click', function() {
            window.print();
        });

        WDN.jQuery('.hoverHelp').on('mouseover', displayHoverHelp);
        WDN.jQuery('.hoverHelp').on('mouseout', hideHoverHelp);
        WDN.jQuery('.hoverHelp').on('click', function() {return false;});

        WDN.jQuery('#ace').on('click', function() {
            WDN.jQuery('#aceOutcomes').attr('disabled', !this.checked);
            WDN.jQuery('#aceOutcomes option').attr('selected', this.checked);
            WDN.jQuery('#aceOutcomes').focus();
        });

        WDN.jQuery('#reset').on('click', function() {
            clearForm(this.form);
            return false;
        });

    });

    var hiddenDepartments;
    var hiddenSubjects;

    var handleChangeSelectHierarchy = function()
    {
        var collegeSelect = WDN.jQuery('#college');
        var departmentSelect = WDN.jQuery('#department');
        var subjectSelect = WDN.jQuery('#subject');

        var selectedCollegeId = collegeSelect.val();
        if (departmentSelect.data('college') != selectedCollegeId) {
            departmentSelect.data('college', selectedCollegeId);
            departmentSelect.find('option').remove();

            hiddenDepartments.find('option').each(function() {
                var multiCollegeDepartmentOverride = false;
                if (this.value == 13 && selectedCollegeId == 2) {
                    multiCollegeDepartmentOverride = true;
                }

                if (WDN.jQuery(this).attr('data-college-id') == selectedCollegeId || selectedCollegeId == 0 || this.value == 0 || multiCollegeDepartmentOverride) {
                    WDN.jQuery(this).clone().appendTo(departmentSelect);
                }
            });
        }

        var selectedDepartmentId = departmentSelect.val();
        if (subjectSelect.data('department') != selectedDepartmentId) {
            subjectSelect.data('department', selectedDepartmentId);
            subjectSelect.find('option').remove();

            hiddenSubjects.find('option').each(function() {
                if (WDN.jQuery(this).attr('data-department-id') == selectedDepartmentId || selectedDepartmentId == 0 || this.value == 0) {
                    WDN.jQuery(this).clone().appendTo(subjectSelect);
                }
            });
        }
    };

    var displayHoverHelp = function(e)
    {
        e = e || window.event;
        var cursor = {x:0, y:0};
        if (e.pageX || e.pageY) {
            cursor.x = e.pageX;
            cursor.y = e.pageY;
        }
        else {
            cursor.x = e.clientX +
                (document.documentElement.scrollLeft || document.body.scrollLeft) -
                (document.documentElement.clientLeft || document.body.clientLeft);
            cursor.y = e.clientY +
                (document.documentElement.scrollTop || document.body.scrollTop) -
                (document.documentElement.clientTop || document.body.clientTop);
        }

        var helpDiv, helpText;
        if(!document.getElementById('floating_help_text_div')) {
            helpDiv = document.createElement('div');
            helpDiv.style.display = 'none';
            helpDiv.id = 'floating_help_text_div';
            helpText = document.createTextNode('');
            helpDiv.style.position = 'absolute';
            helpDiv.appendChild(helpText);
            document.body.appendChild(helpDiv);
        } else {
            helpDiv = document.getElementById('floating_help_text_div');
        }
        if(getElementsByClassName('hoverHelpText', this, 'span')[0].childNodes[0]) {
            helpDiv.childNodes[0].data = getElementsByClassName('hoverHelpText', this, 'span')[0].childNodes[0].data;
            helpDiv.style.borderWidth = '1px';
            if(document.body.clientWidth - cursor.x < cursor.x) {
                helpDiv.style.left = '';
                helpDiv.style.right = (document.body.clientWidth - cursor.x + 5) + 'px';
            } else {
                helpDiv.style.left = (cursor.x + 5) + 'px';
                helpDiv.style.right = '';
            }
            helpDiv.style.top = (cursor.y + 5) + 'px';
            helpDiv.style.display = 'block';
        }
    };

    var hideHoverHelp = function()
    {
        if(document.getElementById('floating_help_text_div')) {
            document.getElementById('floating_help_text_div').style.display = 'none';
        }
    };

})();