WDN.jQuery(function() {

    var nextIndex = -1000;
    var lastAddCourseTime = 0;

    var initAutocomplete = function() {
        WDN.jQuery.ajax({
            url: WDN.jQuery('html').data('baseUrl') + '/fouryearplans/edit/get-course-list'
        }).done(function(courses) {
            var courseSelects = WDN.jQuery('.courseList');
            var courseList = [];


            WDN.jQuery.each(courses, function(courseId, courseCode) {
                courseList.push({
                    value: courseId,
                    label: courseCode.code
                });
            });

            courseSelects.autocomplete({
                source: courseList,
                select: function(event, ui) {
                    lastAddCourseTime = Date.now();

                    var concentration = WDN.jQuery(this).parents('div[data-concentration]').attr('data-concentration');
                    var semester = WDN.jQuery(this).parents('div[data-semester]').attr('data-semester');
                    var courseHtml = '<tr class="course-row">';
                    var nextKey = WDN.jQuery('html').data('nextKey');
                    var inputPrefix = 'courses[' + concentration + '][' + semester + '][' + nextIndex + ']';
                    courseHtml += '<td>' + ui.item.label + '</td>';
                    courseHtml += '<td>';
                    courseHtml += '<span class="text-hours">' + courses[ui.item.value].hours + '</span>';
                    courseHtml += '<input type="text" name="' + inputPrefix + '[hours]" class="input-hours" disabled="disabled" style="display:none;" /> cr';
                    courseHtml += '</td>';
                    courseHtml += '<td>';
                    courseHtml += '<button class="removeCourse">Remove</button>';
                    courseHtml += '<input type="hidden" name="' + inputPrefix + '[type]"  value="course" />';
                    courseHtml += '<input type="hidden" name="' + inputPrefix + '[value]" value="' + ui.item.value + '" />';
                    courseHtml += '</td>';
                    courseHtml += '</tr>';
                    nextIndex--;

                    WDN.jQuery(this).parent().parent().parent().before(courseHtml);

                    this.value = '';
                    return false;
                }
            });
        });
    };

    WDN.loadCSS(WDN.getTemplateFilePath('scripts/plugins/ui/jquery-ui.css'));
    WDN.loadCSS(WDN.getTemplateFilePath('scripts/plugins/ui/ui.datepicker.css'));
    WDN.loadJS(WDN.getTemplateFilePath('scripts/plugins/ui/jQuery.ui.js'), initAutocomplete);

    WDN.jQuery('.semester').on('click', '.removeCourse', function(event) {
        WDN.jQuery(this).parent().parent().remove();
        return false;
    });

    WDN.jQuery('.semester').on('click', '.addCourse', function(event) {
        lastAddCourseTime = Date.now();

        var concentration = WDN.jQuery(this).parents('div[data-concentration]').attr('data-concentration');
        var semester = WDN.jQuery(this).parents('div[data-semester]').attr('data-semester');
        var inputText = WDN.jQuery(this).parent().prev().find('input').val();
        var textHtml = '<tr class="text-row">';
        var nextKey = WDN.jQuery('html').data('nextKey');
        var inputPrefix = 'courses[' + concentration + '][' + semester + '][' + nextIndex + ']';
        textHtml += '<td>';
        textHtml += '<input type="hidden" name="' + inputPrefix + '[type]"  value="text" />';
        textHtml += '<input type="text" name="' + inputPrefix + '[value]" value="' + inputText + '"/>';
        textHtml += '</td><td>';
        textHtml += '<input type="text" name="' + inputPrefix + '[hours]" class="input-hours" /> cr';
        textHtml += '</td><td>';
        textHtml += '<button class="removeCourse">Remove</button>';
        textHtml += '</td>';
        textHtml += '</tr>';
        nextIndex--;

        WDN.jQuery(this).parent().parent().before(textHtml);

        WDN.jQuery(this).parent().prev().find('input').val('');
        return false;
    });

    WDN.jQuery('.courseList').on('keypress', function(event) {
        if (event.which != WDN.jQuery.ui.keyCode.ENTER) {
            return true;
        }

        // Don't fire another click event if we recently added a course.
        // Firefox seems to want to do this if we don't stop it.
        if (Date.now() < lastAddCourseTime + 250) {
            return false;
        }

        WDN.jQuery(this).parent().parent().next().find('button').click();
        return false;
    });

    var newTabIndex = 0;

    WDN.tabs.useHashChange = false;
    WDN.jQuery('ul.wdn_tabs').on('tabchanged', function() {
        var selectedTab = WDN.jQuery(this).find('.selected');
        if (selectedTab.find('a').attr('href') != '#concentration-stub') {
            return;
        }

        newTabIndex++;

        var newTab = selectedTab.clone();
        selectedTab.before(newTab);

        newTab.find('a').attr('href', '#concentration-new' + newTabIndex);
        newTab.find('a span.name').text('New Concentration');

        var stubContent = WDN.jQuery('#concentration-stub');
        var newContent = stubContent.clone();
        newContent.attr('id', 'concentration-new' + newTabIndex);
        newContent.attr('data-concentration', 'new' + newTabIndex);

        var concentrationName = newContent.find('.concentration-name');
        concentrationName.attr('id', 'concentrations-new' + newTabIndex);
        concentrationName.attr('name', 'concentrations[new' + newTabIndex + ']');
        concentrationName.val('New Concentration');

        var concentrationNotes = newContent.find('.concentration-notes');
        concentrationNotes.attr('id', 'notes-new' + newTabIndex);
        concentrationNotes.attr('name', 'notes[new' + newTabIndex + ']');

        stubContent.before(newContent);

        initAutocomplete();

        setTimeout(function() {
            newTab.find('a').trigger('click');
        }, 50);
    });
    WDN.jQuery('ul.wdn_tabs').on('click', '.minibutton.remove', function() {
        var tab = WDN.jQuery(this).parent().parent();
        var content = WDN.jQuery(tab.find('a').attr('href'));

        tab.remove();
        content.remove();
        return false;
    });

    WDN.jQuery('.wdn_tabs_content').on('keyup', '.concentration-name', function() {
        WDN.jQuery('.wdn_tabs .selected a span.name').text(this.value);
    })

    WDN.jQuery('.semester').on('click', '.course-row .text-hours', function() {
        var self = WDN.jQuery(this);
        self.hide();

        self = self.next();
        self.removeAttr('disabled');
        self.show();
        self.focus();
    });

    WDN.jQuery('.semester').on('blur', '.course-row .input-hours', function() {
        var self = WDN.jQuery(this);
        if (self.val() && self.val().trim() != self.prev().text().trim()) {
            return;
        }
        self.hide();
        self.attr('disabled', 'disabled');
        self.prev().show();
    })

});
