var actionTypeSelectAjaxResponder = AjaxClient.extend(
{
    selectElement: null,

    processResponse: function() {
        var resultNodes = this.requestObject.responseXML.childNodes[0].childNodes;
        var resultStrings = new Array();
        for (var i = 0; i < resultNodes.length; i++) {
            var resultNode = resultNodes[i];
            resultStrings.push(resultNode.getAttribute("name"));
        }

        this.selectElement.options.length = 0;
        this.selectElement.add(new Option('--N/A--', '_null', false, false), null);
        for (var i = 0; i < resultStrings.length; i++) {
            var resultString = resultStrings[i]
            this.selectElement.add(new Option(resultString, resultString, false, false), null);
        }
    }
});

var updateEditActionDetailsAjaxResponder = AjaxClient.extend(
{
    actionElement: null,

    processResponse: function() {
        var detailsDiv = this.actionElement.parentNode;
        while (detailsDiv.nextSibling) {
            detailsDiv = detailsDiv.nextSibling;
            if (detailsDiv.className == 'editApprovalChainSpecifics') {
                break;
            }
        }
        while (detailsDiv.childNodes.length > 0) {
            detailsDiv.removeChild(detailsDiv.childNodes[0]);
        }

        if(!this.requestObject.responseXML) {
            return;
        }

        var editXHTML = this.requestObject.responseXML.childNodes[1].childNodes[0];
        while (editXHTML.childNodes.length > 0) {
            detailsDiv.appendChild(editXHTML.childNodes[0]);
        }
        var clearDiv = document.createElement('div');
        clearDiv.className = 'clear';
        detailsDiv.appendChild(clearDiv);
    }
});


function loadApprovalChainManager()
{
    var actionSelectElements = getElementsByClass('actionSelectElement');
    for(var i = 0; i < actionSelectElements.length; i++) {
        var actionSelectElement = actionSelectElements[i];
        actionSelectElement.onchange = updateActionResults;
    }

    var actionTypeSelects = getElementsByClass('actionTypeSelect');
    for (var i = 0; i < actionTypeSelects.length; i++) {
        actionTypeSelects[i].onchange = updateEditActionDetails;
    }
}

addLoadEvent(loadApprovalChainManager);



function selectLinksOrActions()
{
    if(this.id == 'select_manage_links') {
        document.getElementById('manage_links').style.display = '';
        document.getElementById('manage_actions').style.display = 'none';
    } else {
        document.getElementById('manage_links').style.display = 'none';
        document.getElementById('manage_actions').style.display = '';
    }
}




var _serverActionList = new Array();

function saveActionList(response)
{
    if (req.readyState != 4) {
        return;
    }
    if (req.status != 200) {
        return;
    }

    _serverActionList = new Array();

    actionXML = req.responseXML;
    for (var i = 0; i < actionXML.childNodes.length; i++) {
        var currentActionNode = actionXML.childNodes[i];
        var currentAction = new Object();
        currentAction.name = currentActionNode.getAttribute('name');
        currentAction.className = currentActionNode.getAttribute('className');
        currentAction.results = new Array();
        for (var j = 0; j < currentActionNode.childNodes.length; j++) {
            currentAction.results[j] = currentActionNode.childNodes[j].getAttribute('name');
        }
        _serverActionList[i] = currentAction;
    }
}


function updateActionResults()
{
    var actionResultElement = this.parentNode;
    for(actionResultElement = actionResultElement.nextSibling;
        actionResultElement.nodeName.toLowerCase() != 'td';
        actionResultElement = actionResultElement.nextSibling);

    actionResultElement = actionResultElement.getElementsByTagName('select').item(0);

    if (this.value == '_null') {
        actionResultElement.options.length = 0;
        actionResultElement.add(new Option('--N/A--', '_null', false, false), null);
    } else {
        var responder = new actionTypeSelectAjaxResponder();
        responder.selectElement = actionResultElement;
        responder.sendRequest(baseUrl + '/requests/approval-chain-manager/get-action-detail-xml/id/' + this.value);
    }
}

function updateEditActionDetails()
{
    var chainId = document.getElementById('chainId').value;
    var url = baseUrl + '/requests/approval-chain-manager/get-action-edit-xhtml/action-class/' + this.value + '/chain-id/' + chainId;
    WDN.jQuery.ajax({
        url: url,
        context: this.parentNode.parentNode,
        success: function(data) {
            WDN.jQuery(this).find('.editApprovalChainSpecifics').html(data);
        }
    });
}

function handleAddRecord()
{
    var currentTR = this.parentNode.parentNode;
    var currentTable = currentTR.parentNode;
    var hiddenTR = currentTR.previousSibling.previousSibling;
    var currentIndex = currentTable.getElementsByTagName('tr').length - 2;

    var newNode = hiddenTR.cloneNode(true);
    for(var i = 1; i < newNode.childNodes.length; i+=2) {
        var inputElement = newNode.childNodes[i].childNodes[1];
        inputElement.disabled = false;
        var keyIndex = inputElement.name.indexOf('__key__');
        if(keyIndex > 0) {
            inputElement.name = inputElement.name.substr(0, keyIndex) + '-' + currentIndex + inputElement.name.substr(keyIndex + 7);
            inputElement.id = inputElement.name;
        }
    }
    newNode.childNodes[newNode.childNodes.length - 2].childNodes[1].onclick = handleRemoveRecord;
    currentTable.insertBefore(newNode, hiddenTR);
    newNode.className = '';

    return false;
}

function handleRemoveRecord()
{
    var currentTR = this.parentNode.parentNode;
    var currentTable = currentTR.parentNode;

    if(this.id.substr(0, 20) == 'remove_tie_in_button') {
        var addButtonId = 'add' + this.id.substr(6);
        document.getElementById(addButtonId).style.display = 'inline';
    }

    currentTable.removeChild(currentTR);

    return false;
}


jsPlumb.bind('ready', function() {
    var chain = WDN.jQuery('#chain');
    var removedLinks = {};

    WDN.loadJS(WDN.getTemplateFilePath('scripts/plugins/ui/jQuery.ui.js'), function () {
        jsPlumb.importDefaults({
            Anchor: 'Continuous',
            Connector: ['Flowchart', {cornerRadius: 5}],
            ConnectionOverlays: [["Arrow", {
                location: 1,
                id: "arrow",
                length: 14,
                foldback: 0.7
            }]],
            Endpoint: 'Blank',
            PaintStyle: {lineWidth: 2, strokeStyle: '#c00'}
        });

        var createLink = function(data) {
            var link = jsPlumb.connect({
                source: 'action-' + (data.from ? data.from : 'enter-chain'),
                target: 'action-' + (data.to   ? data.to   : 'exit-chain'),
                overlays: [['Label', {
                    id: 'label-' + data.id,
                    label: data.state,
                    cssClass: 'link-label' + (data.state ? '': ' other'),
                    location: 0.2
                }]],
                connector: (data.from == data.to ? 'StateMachine' : ['Flowchart', {cornerRadius: 5}])
            });
            link.data.id = data.id;

            if (data.id && removedLinks[data.id]) {
                delete removedLinks[data.id];
            }
        };

        var getConnectionLabel = function(connection) {
            var label = null;
            WDN.jQuery.each(connection._jsPlumb.overlays, function() {
                if (!(this instanceof jsPlumb.Overlays.Label)) {
                    return;
                }
                label = this;
            });
            return label;
        };

        var changeStateForm = WDN.jQuery('#change-state-form');
        changeStateForm.action = changeStateForm.find('.action-name');
        changeStateForm.state = changeStateForm.find('.state-select');
        changeStateForm.dialog({
            autoOpen: false,
            modal: true,
            buttons: {
                'Update': function() {
                    var data = changeStateForm.link.data;
                    data.state = (changeStateForm.state.val() == '_null' ? null : changeStateForm.state.val());
                    try {
                        // For some reason this sorta fails when removing a loopback connection.
                        jsPlumb.detach(changeStateForm.link);
                    } catch (e) {}
                    createLink(data);

                    WDN.jQuery(this).dialog('close');
                },
                'Remove': function() {
                    try {
                        // For some reason this sorta fails when removing a loopback connection.
                        jsPlumb.detach(changeStateForm.link);
                    } catch (e) {}
                    WDN.jQuery(this).dialog('close');
                },
                'Cancel': function() {
                    WDN.jQuery(this).dialog('close');
                }
            }
        });

        var nextConnectionId = -1;
        jsPlumb.bind('connection', function(info) {
            info.connection.label = getConnectionLabel(info.connection);

            if (!info.connection.label) {
                info.connection.addOverlay(['Label', {
                    id:       null,
                    label:    null,
                    cssClass: 'link-label other',
                    location: 0.2
                }]);
                info.connection.label = getConnectionLabel(info.connection);
            }

            info.connection.data = {
                id:    nextConnectionId--,
                from:  (info.source.id == 'action-enter-chain' ? null : info.source.id.substr(7)),
                to:    (info.target.id == 'action-exit-chain'  ? null : info.target.id.substr(7)),
                state: (info.connection.label.labelText ? info.connection.label.labelText : null)
            };

            info.connection.bind('click', function(connection) {
                changeStateForm.dialog('open');
                changeStateForm.action.text(connection.source.textContent);
                changeStateForm.state.find('option').remove();
                changeStateForm.state.append('<option value="_null">-Other-</option>');
                WDN.jQuery.each(WDN.jQuery(connection.source).data('options'), function() {
                    changeStateForm.state.append('<option>' + this + '</option>');
                });
                changeStateForm.state.val(connection.data.state);
                changeStateForm.link = connection;
            });
        });

        jsPlumb.bind('beforeDrop', function(info) {
            createLink({
                id:    nextConnectionId--,
                from:  info.sourceId.substr(7),
                to:    info.targetId.substr(7),
                state: null
            });
            return false;
        });

        jsPlumb.bind('beforeDetach', function(connection) {
            if (connection.data.id) {
                removedLinks[connection.data.id] = connection.data.id;
            }
            return true;
        });


        WDN.jQuery.ajax({
            url: WDN.jQuery('html').data('baseUrl') + '/requests/approval-chain-manager/get-approval-chain/id/' + chain.data('id'),
            success: function(data) {
                WDN.jQuery.each(data.actions, function(id) {
                    var action = WDN.jQuery('<div class="action">' + this.name + '<div class="source"></div></div>')
                    action.attr('id', 'action-' + id);
                    action.css('top',  this.position.x + 'px');
                    action.css('left', this.position.y + 'px');
                    action.data('options', this.options);
                    chain.append(action);
                });
                WDN.jQuery('#action-exit-chain .source').remove();

                WDN.jQuery.each(data.links, function() {
                    createLink(this);
                });

                var actions = WDN.jQuery('.action');
                jsPlumb.draggable(actions);
                jsPlumb.makeSource(actions, {
                    filter: '.source',
                    anchor: 'Continuous',
                });
                jsPlumb.makeTarget(actions, {
                    anchor: 'Continuous',
                });


            }
        });

    });

    WDN.jQuery('#save-chain').on('click', function() {
        var data = {id: chain.data('id'), actions: {}, links: {}};

        chain.find('.action').each(function() {
            var id = this.id;
            if (id.substr(0, 6) == 'action') {
                id = id.substr(7);
            }

            var action = WDN.jQuery(this);
            data.actions[id] = {
                id: id,
                x:  action.css('top').slice(0, -2),
                y:  action.css('left').slice(0, -2)
            };
        });

        WDN.jQuery.each(jsPlumb.getAllConnections(), function() {
            data.links[this.data.id] = this.data;
        });
        data.removedLinks = removedLinks;

        WDN.jQuery.ajax({
            url: WDN.jQuery('html').data('baseUrl') + '/requests/approval-chain-manager/save-approval-chain',
            type: 'POST',
            data: data,
            success: function(data) {
                console.log(data);
            }
        });
        return false;
    });
});
