<?php

/**
 * Interface Creq_Model_UtilityInterface
 *
 * Provides an interface for doing common queries against a module's documents.
 */
interface Creq_Model_UtilityInterface
{
    /**
     * @param $data
     * @return null
     *
     * Used to populate any extra data that should be attached to a request handled
     * by the given module.  Each row in the $data array is a request for the given
     * module, keyed by the requestId.  The special key "extra" can be used to add
     * additional information to the "My Requests" page.
     */
    static public function loadAdditionalData(&$data);

    /**
     * @param $requests
     * @return array
     *
     * Given an array of requests, return an array where each key is the requestId
     * and the value is the name of the college associated with the request, or NULL
     * if not applicable.
     */
    static public function getCollegesForRequests($requests);

    /**
     * @param $requests
     * @return array
     *
     * Given an array of requests, return an array where each key is the requestId
     * and the value is the name of the major associated with the request, or NULL
     * if not applicable.
     */
    static public function getMajorsForRequests($requests);
}
