<?php

class Creq_Terms
{
    // Returns a list of upcoming terms for the next 5 years
    static public function getFutureTerms()
    {
        $now = new Zend_Date();
        $month = $now->get(Zend_Date::MONTH);
        $thisYear = $now->get(Zend_Date::YEAR);
        $nextYear = $thisYear + 1;
        $prefix = 'No sooner than ';

        $terms = array();
        if ($month < 4) {
            $terms['1' . substr($thisYear, 2) . '8'] = $prefix . 'Fall ' . $thisYear;
        }
        if ($month < 10) {
            $terms['1' . substr($nextYear, 2) . '1'] = $prefix . 'Spring ' . $nextYear;
        }
        $terms['1' . substr($nextYear, 2) . '8'] = $prefix . 'Fall ' . $nextYear;
        
        for ($year = $nextYear+1; $year < $thisYear + 5; $year++) {
            $terms['1' . substr($year, 2) . '1'] = $prefix . 'Spring ' . $year;
            $terms['1' . substr($year, 2) . '8'] = $prefix . 'Fall ' . $year;
        }

        return $terms;
    }
    
    // Returns the earliest term code that can be used as an "Effective Semester"
    static public function getNextTermCode()
    {
        return array_shift(array_keys(self::getFutureTerms()));
    }
}
