<?php

class Creq_View_Helper_BulletinEntry
{
    public function bulletinEntry(Courses_CourseModel $course, Requests_RequestModel $request = null)
    {
        $requestIsIntegratedStudies = false;
        $requestIsRemoveCourse = false;

        if ($request) {
            $requestIsIntegratedStudies = ($request->getType() == 'NewCourseWithIS' || $request->getType() == 'AddISToCourse');
            $requestIsRemoveCourse = ($request->getType() == 'RemoveCourse');
        }

        ob_start();
        ?>
        <div class="bulletinEntry">
            <div>
                <?php if ($requestIsRemoveCourse) { ?>
                <del>
                <?php }
                
                // ACE
                
                if (count($course->getAceOutcomes()) > 0) {
                    $outcomeList = array();
                    foreach ($course->getAceOutcomes() as $outcome) {
                        $outcomeList[] = substr($outcome['slo'], 3);
                    }
                    echo '(ACE ' . implode(', ', $outcomeList) . ')';
                }
                
                // ES and IS

                if ($course->isEssentialStudies() == true) {
                    echo '[ES]';
                }

                if ($course->isIntegratedStudies() || $requestIsIntegratedStudies) {
                    echo '[IS]';
                }
                ?>
                <b>
                <?php
                // subject
                echo $course->getCourseCode();

                ?>.
                <?php echo htmlentities($course->getTitle(), NULL, 'UTF-8'); //title ?>
                </b>
                <?php
                if ($course->getCrosslistingsText()) {
                	echo '(' . $course->getCrosslistingsText() . ')';
                }
                ?>

                <?php
                // credits
                echo $course->getCreditsText();
                ?>

                <?php
                // campuses
                $campuses = $course->getCampuses();
                if (count($campuses) > 1 || !in_array($campuses[0], array('UNL', ''))) {
                    echo '(' . implode(', ', $campuses) . ')';
                }
                ?>

                <?php
                // activities
                echo $course->getActivityText();

                ?>
                <?php if($course->getPrerequisite() != '') { ?>
                Prereq: <?php echo $course->getPrerequisite(); ?>
                <?php } ?>
                <em><?php echo $course->getNotes(); ?></em>

                <?php if ($requestIsRemoveCourse) { ?>
                </del>
                <?php } ?>
            </div>

            <?php if ($requestIsRemoveCourse) { ?>
            <del>
            <?php } ?>
            <?php echo $course->getDescription(); ?>
            <?php if ($requestIsRemoveCourse) { ?>
            </del>
            <?php } ?>


        </div>
        <?php
        return ob_get_clean();
    }
}