<?php
/**
 * @package Exception
 *
 * Copyright 2010-2013 Horde LLC (http://www.horde.org/)
 *
 * See the enclosed file COPYING for license information (LGPL). If you
 * did not receive this file, see http://www.horde.org/licenses/lgpl21.
 */

/**
 * Horde_Exception_Translation is the translation wrapper class for Horde_Exception.
 *
 * @author  Jan Schneider <jan@horde.org>
 * @package Exception
 */
class Horde_Exception_Translation extends Horde_Translation
{
    /**
     * Returns the translation of a message.
     *
     * @var string $message  The string to translate.
     *
     * @return string  The string translation, or the original string if no
     *                 translation exists.
     */
    static public function t($message)
    {
        self::$_domain = 'Horde_Exception';
        self::$_directory = '/Volumes/Storage/Network_Users/tsteiner/Sites/CREQ3/vendor/pyrus/data' == '@'.'data_dir'.'@' ? __DIR__ . '/../../../locale' : '/Volumes/Storage/Network_Users/tsteiner/Sites/CREQ3/vendor/pyrus/data/Horde_Exception/locale';
        return parent::t($message);
    }

    /**
     * Returns the plural translation of a message.
     *
     * @param string $singular  The singular version to translate.
     * @param string $plural    The plural version to translate.
     * @param integer $number   The number that determines singular vs. plural.
     *
     * @return string  The string translation, or the original string if no
     *                 translation exists.
     */
    static public function ngettext($singular, $plural, $number)
    {
        self::$_domain = 'Horde_Exception';
        self::$_directory = '/Volumes/Storage/Network_Users/tsteiner/Sites/CREQ3/vendor/pyrus/data' == '@'.'data_dir'.'@' ? __DIR__ . '/../../../locale' : '/Volumes/Storage/Network_Users/tsteiner/Sites/CREQ3/vendor/pyrus/data/Horde_Exception/locale';
        return parent::ngettext($singular, $plural, $number);
    }
}
